--load required functions from the Lib fodler
local MachSkinCheck = MachAddon.MachSkinCheck
--local FailVibeCheck = MachAddon.FailVibeCheck
local StateSetter = MachAddon.StateSetter
local speedCalc = MachAddon.speedCalc

--make a table for the charge values
--This decides Mach's boost speed from his charge level
local levelSpeeds = {
	[1] = { --balance mode on
		[0] = 0,
		[1] = 45,
		[2] = 55,
		[3] = 75,
		[4] = 75
	},
	[2] = { --balance mode off
		[0] = 0,
		[1] = 60,
		[2] = 70,
		[3] = 90,
		[4] = 110
	}
}

//making a local function to reduce lines of code
local function Unboostify(player, pmo, pskin)
	--no longer boosting...
	if player.machvars.isBoosting then
		player.machvars.isBoosting = false
	end
	
	/*check put in to ensure mach is out of level 2 run state when not
	boosting anymore*/
	if pmo.state == S_PLAY_DASH
		pmo.state = S_PLAY_WALK
	end
	player.normalspeed = skins[pskin].normalspeed
	player.acceleration = skins[pskin].acceleration
	player.charflags = $ & ~SF_RUNONWATER
end

local function ChargeMechanic(player)
	if not MachSkinCheck(player) then
		return
	end
	
	local pmo = player.mo
	local machOnGround = P_IsObjectOnGround(pmo)
	local pscale = pmo.scale
	local pstate = pmo.state
	local pflags = player.pflags
	local pskin = pmo.skin
	local pangle = player.drawangle
	
	
	//this changes mach's boost speed based on charge level
	//found a much more efficient way to do this using simple math
	player.machvars.staticCharge = max($, 0)
	player.machvars.staticCharge = min($, 800)
	player.machvars.barsFilled = player.machvars.staticCharge / 200
	
	--Set the boost value based on the charge level
	player.machvars.boostspeed = levelSpeeds[MachAddon.IsMachBalanced][player.machvars.barsFilled]
	//this handles boost & how mach charges up his barsFilled while running
	if speedCalc(pmo) >= (2 * pscale)
	and (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0) then
		--if player.machvars.barsFilled < 4 and machOnGround then
		
		--Walking charge
		if machOnGround and not (pflags & PF_SPINNING) then
			if player.machvars.barsFilled < 1 then --and (player.cmd.buttons & BT_CUSTOM1)
				player.machvars.staticCharge = $ + 3
			elseif player.machvars.barsFilled < 2 then
				player.machvars.staticCharge = $ + 2
			elseif player.machvars.barsFilled > 2 and not player.machvars.isBoosting then
				player.machvars.staticCharge = $
			else
				player.machvars.staticCharge = $ + 1
			end
		end
		
		--Boosting code
		if (player.cmd.buttons & BT_CUSTOM1) and player.machvars.barsFilled > 0
		and not player.machvars.BadVibes then
			if player.normalspeed == skins[pskin].normalspeed and machOnGround
				if pstate == S_PLAY_ROLL and pflags & PF_SPINNING
					StateSetter(pmo, S_PLAY_WALK)
					player.pflags = $ & ~PF_SPINNING
				end
				
				--we are boosting now!
				if not player.machvars.isBoosting then
					player.machvars.isBoosting = true
				end
				
				--before the insta thrust, lets adjust the player's angle
				
				P_InstaThrust(pmo, pangle, 
						player.machvars.boostspeed * pscale)
				S_StartSound(pmo, sfx_mchbst)
				S_StartSound(pmo, sfx_beelec)
				P_SpawnMobjFromMobj(pmo, 0, 0, 0, MT_BOOSTAURA).target = pmo
				player.normalspeed = player.machvars.boostspeed * FRACUNIT
			elseif player.normalspeed > skins[pskin].normalspeed
				player.normalspeed = player.machvars.boostspeed * FRACUNIT
				player.acceleration = skins[pskin].acceleration * 2
				if not (pmo.eflags & MFE_UNDERWATER or pmo.eflags & 
						MFE_GOOWATER)
					player.charflags = $ | SF_RUNONWATER
				end
				
				if player.machvars.barsFilled > 1 then --no damage in level 1 boost
					player.powers[pw_strong] = STR_ANIM|STR_PUNCH|STR_SPIKE|STR_WALL
					//this'll be where i plop the new code for level 2 run state
					if pmo.state == S_PLAY_RUN
						pmo.state = S_PLAY_DASH
					end
					
					
					--I, Pikaspoop, made this code
					--I originally did this for Battlemod Silverhorn but
					--I wanna use it for Mach too
					
					--basically this will spawn an electric trail but only
					--if mach is able to damage enemies
					
					local trRadius = -60 * pscale
					--triginomotry is pain
					local newx = FixedMul(trRadius, sin(pangle + ANGLE_90))
					local newy = FixedMul(trRadius, cos(pangle - ANGLE_90))
					
					local boosteffect = P_SpawnMobjFromMobj(pmo, newx, newy, 0,
							MT_BOOSTTRAIL)
					boosteffect.angle = pangle
					boosteffect.scale = pscale
					boosteffect.target = pmo
					boosteffect.fade = 1
					
					
				end
			end
		else
			Unboostify(player, pmo, pskin)
		end
	else
		Unboostify(player, pmo, pskin)
	end
end

--Hooks
addHook("PlayerThink", ChargeMechanic)
