--load lib functions we use
local MachSkinCheck = MachAddon.MachSkinCheck

--Allows Mach to avoid being harmed by electric damage
--Also handles the loss of charge on any other hit
local function ElectricImmunity(target, inflictor, source, damage, damagetype)
	if target.skin == "mach" then
		if damagetype == DMG_ELECTRIC then
			target.player.machvars.staticCharge = $ + 1
			return true
		else
			target.player.machvars.staticCharge = $ - 200
			return
		end
	end
end

--The next two functions below here fixes a bug where electric-immune
--characters phase through brak eggman.

--This function checks if brak's barrier dies, and then makes brak NOT solid
local function BarrierIsDead(elec)
	--print("Barrier died!")
	local brak = elec.target
	if not brak.type == MT_CYBRAKDEMON then
		--print("Not brak?")
		return
	end
	brak.flags = $ & ~MF_SOLID
	--print("Brak should be NOT solid")
end

--This function checks if brak's barrier spawns, and then makes brak solid
local function BarrierIsAlive(elec)
	--don't run if the barrier was checked
	if elec.mach_madeSolid then
		return
	end
	
	--print("Barrier Spawned!")
	local brak = elec.target
	if brak == nil then		
		elec.mach_madeSolid = true
		--print("Barrier has no target!")
		return
	end
	if not brak.type == MT_CYBRAKDEMON then
		--print("Not brak?")
		--this doesn't belong to Brak, stop checking
		elec.mach_madeSolid = true
		return
	end
	brak.flags = $ | MF_SOLID
	--brak is now solid, stop checking
	elec.mach_madeSolid = true
	--print("Brak should be solid")
end


--Hooks
addHook("MobjDamage", ElectricImmunity, MT_PLAYER)
addHook("MobjDeath", BarrierIsDead, MT_CYBRAKDEMON_ELECTRIC_BARRIER)
addHook("MobjThinker", BarrierIsAlive, MT_CYBRAKDEMON_ELECTRIC_BARRIER)