--set freeslots
freeslot("sfx_ovrcrg")
sfxinfo[sfx_ovrcrg].caption = "Danger! Overcharge!"

--load required functions from the Lib fodler
local MachSkinCheck = MachAddon.MachSkinCheck
local StateSetter = MachAddon.StateSetter

local function Overcharge(player)
	if not MachSkinCheck(player) then
		return
	end
	
	if player.machvars.xplodetimer == nil
		player.machvars.xplodetimer = -1
	end
	
	//this makes the player explode if they overcharge while boosting
	if player.machvars.xplodetimer > 0
		player.mo.momx = 0
		player.mo.momy = 0
		P_SetObjectMomZ(player.mo, 0)
		StateSetter(player.mo, S_PLAY_PAIN)
		player.machvars.staticCharge = 800
		player.machvars.xplodetimer = $ - 1
		player.pflags = $ | PF_FULLSTASIS
	elseif player.machvars.xplodetimer == 0
		if MachAddon.IsMachBalanced == 2 then
			P_BlackOw(player) --only explode is not in balanced mode
		end
		player.pflags = $ | PF_FULLSTASIS
		P_KillMobj(player.mo)
		player.machvars.xplodetimer = $ - 1
	end
	//this handles the debuffs coming from overcharge
	if player.machvars.barsFilled == 4 and player.playerstate != PST_DEAD
		if leveltime % 10 == 0
			if player.rings <= 0
				if player.machvars.xplodetimer < 0
					player.machvars.xplodetimer = TICRATE
					S_StartSound(player.mo, sfx_s3k86)
				end
				if S_SoundPlaying(player.mo, sfx_ovrcrg)
					S_StopSoundByID(player.mo, sfx_ovrcrg)
				end
				return
			else
				player.rings = $ - 1
			end
		end
		if leveltime % 2 == 0
			if player.mo.colorized
				player.mo.colorized = false
				player.mo.color = player.skincolor
			else
				player.mo.colorized = true
				player.mo.color = SKINCOLOR_RED
			end
		end
		if not S_SoundPlaying(player.mo, sfx_ovrcrg) and 
				player.machvars.xplodetimer < 0
			S_StartSound(player.mo, sfx_ovrcrg)
		end
	else
		if player.mo.colorized
			player.mo.colorized = false
			player.mo.color = player.skincolor
		end
		if S_SoundPlaying(player.mo, sfx_ovrcrg)
			S_StopSoundByID(player.mo, sfx_ovrcrg)
		end
	end
end

--Hooks
addHook("PlayerThink", Overcharge)