//this handles all the more advanced particles and electric effects

freeslot("MT_BOOSTAURA", "MT_BOOSTTRAIL", "sfx_mchbst")
sfxinfo[sfx_mchbst].caption = "Zoom!"

mobjinfo[MT_BOOSTAURA] = {
	spawnstate = S_CYBRAKDEMONELECTRICBARRIER_SPARK_RANDOMCHOOSE,
	spawnhealth = 1,
	seestate = S_CYBRAKDEMONELECTRICBARRIER_SPARK_RANDOMCHOOSE,
	speed = 10 * FRACUNIT,
	radius = 48 * FRACUNIT,
	height = 160 * FRACUNIT,
	flags = MF_NOCLIP | MF_NOGRAVITY
}
mobjinfo[MT_BOOSTTRAIL] = {
	spawnstate = S_SHOCKWAVE1,
	seestate = S_SHOCKWAVE1,
	spawnhealth = 1,
	speed = 0,
	radius = 16 * FRACUNIT,
	height = 48 * FRACUNIT,
	flags = MF_NOCLIP | MF_NOGRAVITY | MF_SCENERY
}


local function BoostAuraThinker(mo)
	//failsafe for when boost effect somehow gets transferred to another object
	if mo.target.skin != "mach"
		P_RemoveMobj(mo)
		return true
	end
	
	if leveltime % 2 == 0
		mo.state = S_CYBRAKDEMONELECTRICBARRIER_SPARK_RANDOMCHOOSE
	end
	if S_OriginPlaying(mo)
		S_StopSound(mo)
	end
	
	--Remove friendly fire
	--just a test
	mo.mass = 0
	
	mo.colorized = true
	mo.frame = $ | FF_ADD
	if mo.target.player.machvars.barsFilled > 3
		mo.color = SKINCOLOR_RED
	else
		mo.color = mo.target.player.skincolor
	end
	mo.scale = mo.target.scale - mo.target.scale / 3
	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	if mo.target.player.normalspeed <= skins[mo.target.skin].normalspeed and
			mo.target.player.machvars.xplodetimer < 0
		P_RemoveMobj(mo)
	end
	return true
end

--code to handle the boost trail
local function BoostTrailThinker(mo)
	//failsafe for when boost effect somehow gets transferred to another object
	if mo.target.skin != "mach"
		P_RemoveMobj(mo)
		return true
	end
	
	if not mo.mach_init then --only run this the first time
		--Remove friendly fire
		--just a test
		mo.mass = 0
		
		mo.colorized = true
		mo.frame = $ | FF_ADD
		if mo.target.player.machvars.barsFilled > 3
			mo.color = SKINCOLOR_RED
		else
			mo.color = mo.target.player.skincolor
		end
		
		--init code is done, set the variable for furute tics
		mo.mach_init = true
	end
	
	--this handles the animation frames
	if not mo.frameCount then
		mo.frameCount = 4
		mo.frame = $ | 4
	end
	
	mo.frame = $ & ~mo.frameCount
	mo.frame = $ + 1
	
	if mo.frameCount > 4 then
		mo.frameCount = 1
	end

	mo.frame = $ | mo.frameCount
	--animation done
	
	--fade-out and deletion
	--made by Em C
	if leveltime % 4 == 0 then
		if mo.fade > 9 then
			P_RemoveMobj(mo)
			return
		else
			mo.frame = ($) | (mo.fade << FF_TRANSSHIFT)
			mo.fade = $ + 1
		end
	end
	
	return true
end

//hooks
addHook("MobjThinker", BoostAuraThinker, MT_BOOSTAURA)
addHook("MobjThinker", BoostTrailThinker, MT_BOOSTTRAIL)