--To do:
--use P_DoPlayerPain for surge pushback.

--freeslots!
freeslot("sfx_mchtnt")
sfxinfo[sfx_mchtnt].caption = "It's Mach Time!"

--load required functions from the Lib fodler
local MachSkinCheck = MachAddon.MachSkinCheck
local StateSetter = MachAddon.StateSetter

--variables!
local machRadius = 38

local function PushSurge(mach, surge)
	local objType = surge.type
	
	if surge.type ~= MT_PLAYER then
		return
	elseif not (mach.valid and surge.valid) then
		--print("Not Valid!")
		return
	elseif surge.skin ~= "surge" then
		--print("Not surge skin!")
		return
	end
	
	--print("Surge Detected!")
	
	local mScale = mach.scale
	local radius = machRadius * mScale --get the proper range scaled with mach
	
	local dist = FixedHypot(surge.x - mach.x, FixedHypot(surge.y - mach.y, surge.z - mach.z))
	--print(dist, radius)
	
	--don't collect the ring if it's too high up
	if dist > radius then
		--print("Surge is too far away!")
		return
	end
	
	P_DoPlayerPain(surge.player, mach, mach)
end

--This function does the actual blockmap search
local function SurgeDetect(p)
	--time to search!
	local pmo = p.mo
	local radius = (machRadius * 2) * pmo.scale
	local x, y = pmo.x, pmo.y
	
	searchBlockmap("objects", PushSurge, pmo, x - radius,
	x + radius, y - radius, y + radius)
end

--Make the taunt flag enable
--the method is taken from Emmette Clyde
local function StartMachTaunt(p)
	--Local badVibes check to avoid console error
	local badVibes = false
	
	--This avoids a nil value error
	if MachSkinCheck(p) then
		badVibes = p.machvars.BadVibes --carry over the pvar value to a local variable if the player is mach.
		p.mach_wasMach = true --unique pvar for just this script
	elseif p.mach_wasMach then
		badVibes = true --We need to run the code to stop the taunt animation if the player switched from mach
	else
		return
	end
	
	--pmo for conveinence
	local pmo = p.mo
	
	--ok time to do checks!
	if badVibes then
		if pmo.state == S_PLAY_FLY_TIRED and p.mach_wasMach then
			--we only want to change state if the player was Mach
			StateSetter(pmo, S_PLAY_STND) --should prevent sprite errors
		end
		
		p.mach_wasMach = nil --no longer mach
		return
	end

	if (p.cmd.buttons & BT_TOSSFLAG) and P_IsObjectOnGround(pmo)
	and pmo.momx == 0 and pmo.momy == 0 and not p.machvars.mach_taunt
	and pmo.state == S_PLAY_STND then
		S_StartSound(pmo, sfx_mchtnt)
		SurgeDetect(p) --the surge attack is here
		p.machvars.mach_taunt = true
	elseif (not P_IsObjectOnGround(pmo) or pmo.momx ~= 0 or pmo.momy ~= 0)
	and p.machvars.mach_taunt then
		p.machvars.mach_taunt = false
	end
	
	if p.machvars.mach_taunt then
		StateSetter(pmo, S_PLAY_FLY_TIRED)
	end
end

--hooks
addHook("PlayerThink", StartMachTaunt)
