--load lib functions we use
local MachSkinCheck = MachAddon.MachSkinCheck

--This table holds the default player var names
--player vars are set like this: player.machvars.key = var
local playerVars = {
	barsFilled = 0,
	staticCharge = 0,
	boostspeed = 0,
	xplodetimer = -1,
	weakjumped = false,
	spinPress = false,
	spinControlFlag = false,
	invframes = TICRATE,
	isBoosting = false,
	isSpinning = false,
	mach_taunt = false,
	shieldAbility = false,
	BadVibes = 0
}

--set default player bools to the specified value
--overwrites any existing values too
local function SetPlayerVars(p, pVars)
	if not MachSkinCheck(p) then
		return
	end
	if not p.machvars then
		p.machvars = {}
	end
	--this sets the variables outlined in the table
	for k, v in pairs(pVars) do
		p.machvars[k] = v
	end
end

--removes all mach vars safely
local function DelPlayerVars(p, pVars)
	if not p.machvars then
		return
	end
	for k,v in pairs(pVars) do
		p.machvars[k] = nil
	end
	p.machvars = nil
end

--Assign or remove player vars for mach players
addHook("PreThinkFrame", function()
	for p in players.iterate do
		if not p.mo then
			DelPlayerVars(p, playerVars)
			continue
		end
		local skin = p.mo.skin
		if skin ~= "mach" then
			DelPlayerVars(p, playerVars)
		elseif not p.machvars then
			SetPlayerVars(p, playerVars)
		end
	end
end)

--reload mach vars if a map is loaded
addHook("MapChange", function(mapNum)
	for p in players.iterate do
		SetPlayerVars(p, playerVars)
	end
end)

--re-assign mach variables if the player respawns
addHook("PlayerSpawn", function(p)
	SetPlayerVars(p, playerVars)
end)

