--freeslots!
freeslot("sfx_mchthk")
sfxinfo[sfx_mchthk].caption = "Static Thok"

--load required functions from the Lib fodler
local MachSkinCheck = MachAddon.MachSkinCheck
local speedCalc = MachAddon.speedCalc
local StateSetter = MachAddon.StateSetter
//local RedirectPlayerSpeed = MachAddon.RedirectPlayerSpeed
local removeABar = MachAddon.removeABar
local JumpManager = MachAddon.JumpManager

--This holds the normal and balance thok speeds
local balanceThok = {
	[1] = { --balance mode on
		[1] = 45, --minthok
		[2] = 8 --thokSpeedIncrease
	},
	[2] = { --balance mode off
		[1] = 50, --minthok
		[2] = 15 --thokSpeedIncrease
	}
}

--make sure a Thok is possible.
local function ThokCheck(p)
	if not MachSkinCheck(p) then
		return
	elseif not p.machvars.spinPress or p.machvars.BadVibes then
		return false
	end
	
	local pmo = p.mo
	
	if p.machvars.staticCharge >= 200 and not P_IsObjectOnGround(pmo) then
		
		local tempBalance = MachAddon.IsMachBalanced
		local minThokSpeed = balanceThok[tempBalance][1] * pmo.scale
		local thokSpeedIncrease = balanceThok[tempBalance][2] * pmo.scale
		local newSpeed = speedCalc(pmo) + thokSpeedIncrease
		
		if newSpeed < minThokSpeed then
			newSpeed = minThokSpeed
		end
		StateSetter(pmo, S_PLAY_JUMP)
		//RedirectPlayerSpeed(pmo, newSpeed, pmo.angle)
		P_InstaThrust(pmo, p.drawangle, newSpeed)
		JumpManager(pmo, 5 * pmo.scale)
		S_StartSound(pmo, sfx_mchthk)
		removeABar(p)
		
		return true
	end
end

local function ThokTrail(p)
	if not MachSkinCheck(p) then
		return
	end

	local pmo = p.mo
	//this handles the particles and control while spinning
	if not P_IsObjectOnGround(pmo) and pmo.state == S_PLAY_JUMP then
		local thokeffect = P_SpawnMobjFromMobj(pmo, 0, 0, 0, MT_WATERZAP)
		thokeffect.colorized = true
		thokeffect.frame = $ | FF_ADD
		thokeffect.color = p.skincolor
		thokeffect.mass = 0 --remove electric damage
	end
end

--hooks
--activates on each spin press in the air
addHook("JumpSpinSpecial", ThokCheck)
addHook("PlayerThink", ThokTrail)

/*
addHook("PlayerThink", function(p)
	if MachSkinCheck(p) then
		ThokCheck(p)
		ThokTrail(p)
	end
end)
*/
